`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    11:13:01 09/14/2016 
// Design Name: 
// Module Name:    bcast_flag_keep 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module bcast_flag_keep(
    input clk,
    input pps,
    input aresetn,
    input flag_in,
    output flag_out,
    output flag_rst_n
    );

    reg flag_out = 1'b0;
	 reg pps_prev = 1'b0;
	 reg flag_rst_n = 1'b1;
    reg [13:0] conuter_n = 14'd0;
	 //reg [5:0] conuter2_n = 6'd0;
	 reg [4:0] conuter2_n = 5'd0;
    /*****************************************************************************/
    /* MAIN CODE */
    /*****************************************************************************/
    always @(posedge clk)
	 //always @(negedge aclk or negedge aresetn_in)
	 begin
        if (!aresetn)
		    begin
            conuter_n <= 14'h3FFF;//is reset
				//conuter2_n <= 6'h3F;
				conuter2_n <= 5'h1F;
				flag_out <= 1'b0;
   			flag_rst_n <= 1'b1;
          end
		  else
		    begin
          if (flag_in)
		      begin
              conuter_n <= 14'h3FFF;//is reset
				  //conuter2_n <= 6'h3F;
				  conuter2_n <= 5'h1F;
				  flag_out <= 1'b1;
				  flag_rst_n <= 1'b1;
            end
		    else
            if (conuter_n)
              conuter_n <= conuter_n - 1;//not reset
		      else
				  if (flag_out)
		            flag_out <= 1'b0;
				  else
						//this event happened when we don't have signal 2x times per 16 kSamp.
						if (pps && !pps_prev)
						  begin
								if (conuter2_n)
									conuter2_n <= conuter2_n - 1;//not reset
								else
									if (flag_rst_n)
										flag_rst_n <= 1'b0;
									else
										begin
											conuter2_n <= 6'h3F;
											flag_rst_n <= 1'b1;
										end
						  end
				  pps_prev <= pps;
			 end
	 end

endmodule
