module timeinterleave (
        ap_clk,
        ap_rst,
        input_V_dout,
        input_V_empty_n,
        input_V_read,
        output_V_din,
        output_V_full_n,
        output_V_write,
        sram_addr_V,
        sram_databus_V_i,
        sram_databus_V_o,
        sram_databus_t,
        sram_noe,
        sram_nwe
)/*synthesis syn_black_box*/;
input   ap_clk;
input   ap_rst;
input  [8:0] input_V_dout;
input   input_V_empty_n;
output   input_V_read;
output  [8:0] output_V_din;
input   output_V_full_n;
output   output_V_write;
output  [16:0] sram_addr_V;
input  [7:0] sram_databus_V_i;
output  [7:0] sram_databus_V_o;
output   sram_databus_t;
output   sram_noe;
output   sram_nwe;
endmodule

