`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    19:05:24 05/17/2016 
// Design Name: 
// Module Name:    delay_1clk 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////

//https://forums.xilinx.com/t5/DSP-and-Video/fft-core-v7-1-inverse-fft-not-working/td-p/678727
//http://web.mit.edu/6.111/www/f2005/code/fft_sample/fft_sample.v.html#fft_sample
//https://www.xilinx.com/support/documentation/ip_documentation/xfft_ds260.pdf
module delay_1clk(
    input clk,
    input aresetn,
    output reg we,
	 output reg we_done
    );

    always @(posedge clk or negedge aresetn)
	 //always @(negedge aclk or negedge aresetn_in)
	 begin
        if (!aresetn) begin
            we <= 1'b0;//is reset
				we_done <= 1'b0;
        end else begin
            if(!we & !we_done)
					we<=1'b1;
				else if(we) begin
					we_done<=1'b1;
					we<=1'b0;
				end
		  end
	 end
endmodule
